<?php

$enable_mce = true;

include('functions.php');
include('validate.php');
include('settings.php');

session_start();

print_header();

if (isset($_GET['logout'])) {
  session_destroy();
  echo "You have been logged out<br><br>";
  echo "<a href='/admin.php'>Click here to log back in</a>";
  print_footer();
  exit;
}

if (!isset($_SESSION['admin'])) {

  if (isset($_POST['password'])) {
    if ($_POST['password'] == $admin_pwd) {
      $_SESSION['admin'] = true;
    } else {
      echo "Login failed - incorrect password<br><br>";
    }
  }

  if (!isset($_SESSION['admin'])) {
    echo "<form method='post'>";
    echo "Please enter the password to continue: ";
    echo "<input type='password' name='password'>";
    echo "<input type='submit' value='Submit' name='submit'>";
    echo "</form>";
  }
}

if (isset($_SESSION['admin'])) {

  echo "<a href='?logout'>Logout from admin account</a><br>";
  echo "<a href='?users'>View users</a><br>";
  if ($use_tokens) {
      echo "<a href='?tokens'>Create new tokens</a><br>";
      echo "<a href='?viewtokens'>View tokens</a><br>";
  }
  echo "<a href='?announcement'>Edit announcement page</a><br>";
  echo "<hr>";

  /* View tokens page */
  if (isset($_GET['tokens'])) {
  
    echo "<h2>Create New Tokens</h2>";
      
    if (isset($_POST['create'])) {

      $duration = intval($_POST['duration']);
      $quantity = intval($_POST['quantity']);
      
      echo "The following table contains the $quantity tokens. Copy and paste or print it:<br><br>";
      echo "<table cellpadding='20'>";
      
      $tokens = create_tokens($quantity, $duration);
      $i = 0;
      
      foreach ($tokens as $v) {
        if ($i % 4 == 0) {
          echo "<tr><td>$v</td>";
        } elseif ($i % 4 == 1) {
          echo "<td>$v</td>";
        } elseif ($i % 4 == 2) {
          echo "<td>$v</td>";
        } else {
          echo "<td>$v</td></tr>";
        }
        $i++;
      }
      echo "</table>";

    } else {

      echo "<form method='post'>";
      echo "<table>";
      echo "<tr><td>Number of tokens to generate:</td>";
      echo "<td><input type='input' name='quantity' value='100'></td></tr>";
      echo "<tr><td>Duration of token in days:</td>";
      echo "<td><input type='input' name='duration' value='7'></td></tr>";
      echo "<tr><td></td><td><input type='submit' name='create' value='Create tokens'></td></tr>";
      echo "</table>";
      echo "</form>";

    }
        
  /* Create tokens page */
  } elseif (isset($_GET['viewtokens'])) {

    echo "<h2>Token Details</h2>";
      
    echo "<b>Token Stats:</b><br>";
    echo "Total unused tokens: " . tokens_unused() . "<br>";
    echo "Total used tokens: " . tokens_used() . "<br>";
    
    $tokens_month = tokens_count_month();
    foreach ($tokens_month as $v) {
        echo "Used tokens in " . $v['month'] . ": " . $v['count'] . "<br>";
    }
    
    echo "<br><b>All tokens:</b><br>";
    echo "<table><tr><td>ID</td><td>Duration</td><td>Date used</td><td>Name of user</td></tr>";
    $tokens = tokens_all();
    foreach ($tokens as $v) {
        if (!isset($v['used_date'])) { $v['used_date'] = 'Unknown'; }
        if (!isset($v['surname'])) {
            echo "<tr><td>" . $v['id'] . "</td><td>" . $v['duration'] . " days</td>"
                 ."<td><i>Unused</i></td><td><i>Unused</i></td></tr>";
        } else {
            echo "<tr><td>" . $v['id'] . "</td><td>" . $v['duration'] . " days</td>"
                 ."<td>" . $v['used_date'] . "</td><td>" . $v['surname'] . ", " . $v['forename'] . "</td></tr>";
        }
    }
    
  /* View all users page */
  } elseif (isset($_GET['users'])) {

    echo "<h2>User Details</h2>";
    
    // Check for disable / enable of user
    if (isset($_GET['disableuser'])) {
      if (disable_user($_GET['disableuser'])) {
        echo "Account has been disabled<br><br>";
      } else {
        echo "There was an error disabling the account<br><br>";
      }
    } elseif (isset($_GET['enableuser'])) {
      if (enable_user($_GET['enableuser'])) {
        echo "Account has been enabled<br><br>";
      } else {
        echo "There was an error enabling the account<br><br>";
      }
    }
      
    echo "<table cellpadding='3'>";
    echo "<tr><td><b>Serial</b></td>
              <td><a href='?users&sort=surname'>Surname</a></td>
              <td><a href='?users&sort=forename'>Forename</a></td>
              <td><a href='?users&sort=email'>Email</a></td>
              <td><a href='?users&sort=created'>Created</a></td>
              <td><a href='?users&sort=expiry'>Account expiry</a></td>
              <td></td>
              <td></td>
              <td></td>
              </tr>";

    if (isset($_GET['sort'])) {
      if (in_array($_GET['sort'], array('surname','forename','created','expiry','email'))) {
        $_SESSION['sort'] = $_GET['sort'];
      }
    }
    
    if (!isset($_SESSION['sort'])) {
      $_SESSION['sort'] = 'surname';
    }
        
    $i = 1;
    $users = get_all_users($_SESSION['sort']);
    
    foreach ($users as $v) {
      if ($v['disabled']) { $class = "class='error'"; } else { $class = ''; }
      echo "<tr><td>$i</td>";
      echo "<td $class>" . htmlentities($v['surname'],ENT_QUOTES) . "</td>";
      echo "<td $class>" . htmlentities($v['forename'],ENT_QUOTES) . "</td>";
      echo "<td $class>" . htmlentities($v['email'],ENT_QUOTES) . "</td>";
      echo "<td $class>" . $v['created'] . "</td>";
      echo "<td $class>" . $v['expiry'] . "</td>";
      echo "<td><a href='?user=" . $v['id'] . "'>Edit user</a></td>";
      echo "<td><a href='?deleteuser=" . $v['id'] . "'>Delete user</a></td>";
      if ($v['disabled']) {
        echo "<td><a href='?users&enableuser=" . $v['id'] . "'>Enable user</a></td></tr>";
      } else {
        echo "<td><a href='?users&disableuser=" . $v['id'] . "'>Disable user</a></td></tr>";
      }
      $i++;
    }
    
    echo "</table>";
    
  /* View individual users page */
  } elseif (isset($_GET['user'])) {
  
    if (isset($_POST['update'])) {
      if (set_user_details($_POST)) {
        echo "Update succeeded<br><br>";
      } else {
        echo "Update failed<br><br>";
      }
    }
    
    $user = get_user_details($_GET['user']);
    
    echo "<form method='post'><table>";
    echo "<tr><td>Surname:</td><td><input type='text' name='surname' value='" . htmlentities($user['surname'],ENT_QUOTES) . "'></td></tr>";
    echo "<tr><td>Forename:</td><td><input type='text' name='forename' value='" . htmlentities($user['forename'],ENT_QUOTES) . "'></td></tr>";
    echo "<tr><td>Password:</td><td><input type='text' name='password' value='" . htmlentities($user['password'],ENT_QUOTES) . "'></td></tr>";
    echo "<tr><td>Email:</td><td><input type='text' name='email' value='" . htmlentities($user['email'],ENT_QUOTES) . "'></td></tr>";
    echo "<tr><td>Expiry:</td><td><input type='text' name='expiry' value='" . $user['expiry'] . "'> Enter a date in the form yyyy-mm-dd (no time needed)</td></tr>";
    echo "<tr><td></td><td><input type='submit' name='update' value='Update'>";
    echo "</table><input type='hidden' name='id' value='" . $user['id'] . "'></form>";

  /* Delete user page */
  } elseif (isset($_GET['deleteuser'])) {
    if (disable_user($_GET['deleteuser']) && delete_user($_GET['deleteuser'])) {
      echo "User deletion succeeded";
    } else {
      echo "User deletion failed";
    }

  /* Edit announcments page */
  } elseif (isset($_GET['announcement'])) {

    global $announcement_file;

    /* Update announcement file */
    if (isset($_POST['announcement_html']) && isset($_POST['announcement_submit']))
    {
      $result = file_put_contents($announcement_file, "<!--Announcement_name:"
                . $_POST['announcement_name'] . "-->\n" . $_POST['announcement_html']);
      add_announcement($_POST['announcement_name'], $_POST['announcement_html']);
      if ($result === false) {
        echo "<b>File write failed</b>";
      } else {
        echo "<b>File write and update successful</b>";
      }
      /* Write day of file to Squid setting file */
      if (intval($_POST['announcement_dow']) > 0 && intval($_POST['announcement_dow']) < 8) {
        $result = file_put_contents($announcement_dow_file, '%u ' . intval($_POST['announcement_dow']) . "\n");
      }
    }
    
    echo "<form method='post'>";
    echo "<h3>Announcement Page</h3>";
    echo "<p>Edit the text below to set the splash page that is displayed to users
          of the wireless when they first connect for the day. ";
    echo "<a href='announce.php' target='_blank'>Preview Page</a></p>";

    $announcements = get_announcements();

    if (isset($_POST['announcement_load'])) {
      $announcement_text = $announcements[$_POST['announcement_load_id']]['content'];
      $announcement_name = $announcements[$_POST['announcement_load_id']]['name'];
//    } elseif (isset($_POST['announcement_name'])) {
//      $announcement_text = file_get_contents($announcement_file);
 //     $announcement_name = $_POST['announcement_name'];
    } else {
      $announcement_text = file_get_contents($announcement_file);
      $matches = array();
      if (preg_match('/<!--Announcement_name:(.*)-->/', $announcement_text, $matches)) {
        $announcement_name = $matches[1];
        $announcement_text = strstr($announcement_text, "\n");
      } else {
        $announcement_name = 'Enter new name';
      }
    }

    $announcement_dow = file_get_contents($announcement_dow_file);
    
    /* Show previous announcements */
    if (count($announcements) > 0)
    {
      echo "<table cellpadding='6' cellspacing='0'>";
      echo "<tr><td class='bottom'>";
      echo "<b>Load previous announcement:</b></td>";
      echo "<td class='bottom'><select name='announcement_load_id'>";
      foreach ($announcements as $v) {
        echo "<option value='" . $v['id'] . "'>" . $v['name'] . "</option>";
      }
      echo "</select></td>";
      echo "<td class='bottom'><input type='submit' name='announcement_load' value='Load'></td></tr>";
    }

?>            <tr><td><b>Save new announcement page:</b></td>
            <td><input type='textbox' name='announcement_name' value='<?php echo $announcement_name; ?>' />
            
            <select name='announcement_dow'>
            <option value='7' <?php if ($announcement_dow == "%u 7\n") echo 'selected'; ?>>Display on Sundays only</option>
            <option value='1' <?php if ($announcement_dow == "%u 1\n") echo 'selected'; ?>>Display on Mondays only</option>
            <option value='2' <?php if ($announcement_dow == "%u 2\n") echo 'selected'; ?>>Display on Tuesdays only</option>
            <option value='3' <?php if ($announcement_dow == "%u 3\n") echo 'selected'; ?>>Display on Wednesdays only</option>
            <option value='4' <?php if ($announcement_dow == "%u 4\n") echo 'selected'; ?>>Display on Thursdays only</option>
            <option value='5' <?php if ($announcement_dow == "%u 5\n") echo 'selected'; ?>>Display on Fridays only</option>
            <option value='6' <?php if ($announcement_dow == "%u 6\n") echo 'selected'; ?>>Display on Saturdays only</option>
            </select>
            </td><td><input type="submit" name="announcement_submit" value="Save" /></td></tr>
            </table><br>
<?php
    /* Show TinyMCE HTML edit box */
    echo "<textarea id='elm1' name='announcement_html' rows='15' cols='80' style='width: 80%'>";
    echo $announcement_text;
    echo "</textarea>";

    echo "</form>";
  }
  
}

print_footer();

?>
