<?php

include('validate.php');
include('functions.php');
include('settings.php');

session_start();
// Get the original destination if set
if (isset($_GET['dest'])) {
  $_SESSION['dest']=$_GET['dest'];
} elseif (isset($_SERVER['PATH_INFO'])) {
  $_SESSION['dest']=$_SERVER['PATH_INFO']."?".$_SERVER['QUERY_STRING'];
}

// Get the client's mac address
$mac = get_mac_address();
if (!$mac) { $error = 'There was an error identifying your computer'; }

if (isset($_SESSION['dest'])) {
  $dest = "http:/".$_SESSION['dest'];
} else {
  $dest = "http://www.google.co.uk";
}
    
print_header();

$aup = file_get_contents('aup.txt'); 

// First check if we're looking at an internet PC
// If so just show syops

if (isset($internetpc)) {
  if (in_arrayi($mac, $internetpc)) {
    if (!isset($_POST['agree'])) {
      echo "
        You must agree to the Acceptable Use Policy before using these machines:<br><br>

        <form method='post'>

        <table border=0 cellpadding=5 cellspacing=0>
        <tr><td><textarea name='aup' readonly rows='20' cols='80'>$aup</textarea></td></tr>
        <tr><td align=center height='23'><input type='submit' name='agree' value='I agree to the Acceptable Use Policy'></td></tr>
        </table>
        </form>";
    }  else {
      enable_address($mac, 0, $dest, true);
    }
    print_footer();
    exit;
  }
}

if (isset($_GET['logout'])) {

  logout();
    
  echo "You have been logged out";
  print_footer();
  exit;
}

$error = '';
$surname = '';
$forename = '';
$email = '';

// Validate data for new account
if (isset($_POST['signup'])) {

  if (isset($_POST['surname'])) {
    $surname = $_POST['surname'];
    if (!$surname) {
      $error .= "Please enter a surname\n";
    }
  }
    
  if (isset($_POST['forename'])) {
    $forename = $_POST['forename'];
    if (!$forename) {
      $error .= "Please enter a forename\n";
    }
  }

  if (isset($_POST['email'])) {
    $email = $_POST['email'];
    if (!check_email($email)) {
      $error .= "Please enter a valid email address\n";
    }
  }
    
  if ($_POST['password'] != $_POST['password2']) {
    $error .= "The 2 passwords entered do not match\n";
  }  

  if (!check_name($_POST['password'])) {
    $error .= "Please enter a password with printable characters\n";
  }  

  if (!$error) {
    $userid = add_user($_POST['forename'],
                       $_POST['surname'],
                       $_POST['email'],
                       $_POST['password']);
    
    if ($userid == -1) {
      $error .= "The email address entered already exists. Click <a href='/reset.php'>here</a> to reset the password.";
    } elseif ($userid) {
      $_SESSION['userid'] = $userid;
      setcookie("nelsonwr_username",$_POST['email'],time()+60*60*24*90);
    } else {
      $error .= "We failed to add your account due to an unknown error.
                  Please contact support.";
    }
  }
  
  if ($error) { echo nl2br("<span class='error'>$error</span>"); }
  
}

// Log the user in
if (isset($_POST['login'])) {

  $result = login($_POST['username'], $_POST['password_login']);
  if (!$result) {
    $error .= '<span class="error">Login failed - please try again</span>';
  } else {
        setcookie("nelsonwr_username",$_POST['username'],time()+60*60*24*90);
  }
  echo $error;
}

// Show user home page
if (isset($_SESSION['userid'])) {

  $userid = $_SESSION['userid'];
  $user = get_user_details($userid);
  
  if ($user['disabled']) {
    echo "Your account has been disabled.<br><br>";
    echo "<a href='/index.php?logout'>Logout</a><br>";
    print_footer();
    exit;
  }

  if (isset($_POST['acceptaup'])) {
    accept_aup($userid);
    $user['aup'] = 1;
  }

  if (isset($_POST['mailing_list_yes'])) {
    $name = urlencode($user['forename'] . ' ' . $user['surname']);
    $email = urlencode($user['email']);
    $list = urlencode($mailing_list_name);
    fopen ("http://www.simplelists.com/subscribe.php?name=$name&email=$email&action=subscribe&list=$list", 'r');
    mailing_list_done($userid);
    $user['mailing_list'] = 1;
  }

  if (isset($_POST['mailing_list_no'])) {
    mailing_list_done($userid);
    $user['mailing_list'] = 1;
  }

  if (!$user['mailing_list'] && $use_mailing_list) {
  
    // If applicable, give the user a chance to sign up to the Simplelists mailing list
    echo "<table width='800'><tr><td>$mailing_list_msg</td></tr></table><br><br>";
    echo "<form method='post'>";
    echo "<input type='submit' name='mailing_list_yes' value='Yes, please sign me up'> ";
    echo "<input type='submit' name='mailing_list_no' value='No thanks'>";
    echo "</form>";
    
  } elseif (!$user['aup']) {
  
    if (isset($_POST['signup'])) {
      echo "<span class='green'>Thank you, your account has now been registered.</span><br>";
    }
    echo "To continue, you must accept the Acceptable Use Policy:<br><br>";
    echo"<form method='post'>
      <table border=0 cellpadding=5 cellspacing=0>
      <tr><td><textarea name='aup' readonly rows='20' cols='80'>$aup</textarea></td></tr>
      <tr><td align=center height='23'><input type='submit' name='acceptaup' value='I agree to the Acceptable Use Policy'></td></tr>
      </table>
      </form>";
      
  } else {
  
    $result = '';
    if (isset($_POST['credit'])) {
      if(credit($_POST['token'], $userid)) {
        $result = "<span class='green'>Your token was successfully credited to your account</span><br>";
      } else {
        $result = "<span class='error'>Token number invalid - please try again</span><br>";
      }
    }

    if (isset($_POST['update'])) {
      $user['forename'] = $_POST['forename'];
      $user['surname'] = $_POST['surname'];
      $user['email'] = $_POST['email'];
      $user['password'] = $_POST['password'];
      $user['id'] = $userid;
            
      if (set_user_details($user)) {
        echo "Update succeeded<br><br>";
      } else {
        echo "Update failed<br><br>";
      }
    }      

    echo "<table cellpadding='10' cellspacing='10' width='600'><tr><td class='alldotted'>
             $login_page_msg</span></td></tr></table>"; 

    $expiry = strtotime(get_expiry($_SESSION['userid']));

    echo "<table cellpadding='10' cellspacing='10' width='600'>";

    if ( $expiry > time() || !$use_tokens ) {
      // User still has credit

      echo "<tr><td class='all'>";
      echo '<h2>Enable access to the internet</h2>';
      echo "<form method='post'>";
      echo "<input type='submit' name='useinternet' value='Click here to start using the internet'>";
      echo "</form>";
      echo "</td></tr>";
      
      if (isset($_POST['useinternet'])) {


        logout();      
        enable_address($mac, $userid, $dest);
      }
    }
    
    echo "<tr><td class='all'><h2>Account</h2>";

    if ($use_tokens) {
      if ($expiry) {
        echo "<b>Current expiry date:</b> " . date('l jS \of F Y h:i:s A', $expiry) . '<br><br>';
      } else {
        echo "<b>Current expiry date:</b> No credit<br><br>";
      }
    }
    echo "<a href='/index.php?logout'>Logout</a>";

    echo "</td></tr>";
    
    if ($use_tokens) {

      echo "<tr><td class='all'>";
      echo "<h2>Add credit</h2>";
      if ($result) { echo $result; }
      echo "$add_credit_msg<br><br>";
      echo "<form method='post'>";
      echo "Token code: <input type='text' name='token'>
            <input type='submit' value='Credit' name='credit'>";
      echo "</form>";
      echo "</td></tr>";
    }
    
    echo "<tr><td class='all'>";
      
    echo "<h2>Change details</h2>";

    $user = get_user_details($userid);

    echo "<form method='post'><table>";
    echo "<tr><td>Surname:</td><td><input type='text' name='surname' value='" . htmlentities($user['surname'],ENT_QUOTES) . "'></td></tr>";
    echo "<tr><td>Forename:</td><td><input type='text' name='forename' value='" . htmlentities($user['forename'],ENT_QUOTES) . "'></td></tr>";
    echo "<tr><td>Password:</td><td><input type='text' name='password' value='" . htmlentities($user['password'],ENT_QUOTES) . "'></td></tr>";
    echo "<tr><td>Email:</td><td><input type='text' name='email' value='" . htmlentities($user['email'],ENT_QUOTES) . "'></td></tr>";
    echo "<tr><td></td><td><input type='submit' name='update' value='Update'>";
    echo "</table></form>";

    echo "</td></tr>";
      
  }
  echo "</table>";
      
  
} else {

  echo "<table cellpadding='10' cellspacing='5'>";
  echo "<tr><td class='all'>";
  echo "<h2>Sign up for an account</h2>";
  echo "<form method='post'>";
  echo "<table>";
  echo "<tr><td>Forename:</td><td><input type='text' name='forename' value='".htmlentities($forename,ENT_QUOTES)."'></td></tr>";
  echo "<tr><td>Surname:</td><td><input type='text' name='surname' value='".htmlentities($surname,ENT_QUOTES)."'></td></tr>";
  echo "<tr><td>Email:</td><td><input type='text' name='email' value='".htmlentities($email,ENT_QUOTES)."'></td></tr>";
  echo "<tr><td>Choose password:</td><td><input type='password' name='password'></td></tr>";
  echo "<tr><td>Re-enter password:</td><td><input type='password' name='password2'></td></tr>";
  echo "<tr><td></td><td><input type='submit' name='signup' value='Submit'></td></tr>";
  echo "</table></form>";
  echo "</td><td valign='top' class='all' width='400'>";
  echo "<h2>Login with an existing account</h2>";
  echo "<span class='error'>";
  if ($use_tokens) {
    echo "This is not for a token code. Please sign up first using the form on the left and
          enter the token once you have logged in.</span><br><br>";
  } else {
    echo "Please sign up first using the form on the left and
          then login below once you have created an account.</span><br><br>";
  }
  echo "<form method='post'><table>";
  echo "<tr><td>Email:</td><td><input type='text' name='username'";
  if (isset($_COOKIE['nelsonwr_username'])) { echo "value='" . $_COOKIE['nelsonwr_username'] . "'"; }
  echo "></td></tr>";
  echo "<tr><td>Password:</td><td><input type='password' name='password_login'></td></tr>";
  echo "<tr><td></td><td><input type='submit' name='login' value='Login'></td></tr>";
  echo "<tr><td></td><td><a href='reset.php'>Forgotten password?</a></td></tr>";
  echo "</table></form>";
  echo "</td></tr>";
  echo "</table>";
  echo "$initial_page_footer";
}

print_footer();

?>
